
# simple example of a global variable invariant:
# a timer that counts down to zero

time = 0

# we want to maintain true this invariant property:
"""{ globalinv   time >= 0 }"""

# the checker  verifies that the invariant holds true HERE, on initialization.

# the function below can use the invariant, and the function
# must ensure that the invariant holds on exit:

def tick() :
    """{ pre  True 
         post ans == time
         return ans
    }"""
    global time 
    # as needed, we can introduce the globalinv  into a proof:
    """{ 1.  time >= 0         premise   }"""
    if time != 0 :
        time = time - 1
        """{ 1. time_old != 0     premise
             2. time_old >= 0     premise
             3. time_old > 0      algebra 1 2
             4. time == time_old - 1    premise
             5. time >= 0         algebra 3 4
        }"""
    else :
        print "RING RING RING"
        """{ 1.  time >= 0     premise  }"""
    ans = time
    # we have proved enough facts that the checker can verify that the
    # invariant holds true and so does the function's postcondition
    return ans


def init(starttime) :
    """{ pre  starttime > 0
         post True
    }"""
    global time
    time = starttime
    # the checker easily verifies the global invariant:  time >= 0


# Driver code starts here: run the timer

# invariant holds true
novar = init(10)
# invariant holds true
a = tick()
# invariant holds true
a = tick()
# invariant holds true
a = tick()
# invariant holds true

